
--I THINK IT MAKES SENSE TO JUST HAVE A MANY TO ONE RELATIONSHIP TO START,
--A USER CAN HAVE MANY ACCOUNTS BUT AN ACCOUNT IS ASSIGNED TO ONE USER,
--THIS DOES GET TRICKY WITH THE OPTIONAL JOINT ACCOUNT HOWEVER, I BELIEVE,
--SIMPLY PUTTING A SECONDARY ON THE BANK USER CAN BE USED TO TAKE CARE OF THAT,
-- AND STILL PRESERVE THE MANY TO 1 RELATIONSHIP. TBD IF I AM RIGHT.
CREATE TABLE ACCOUNT(
	ACCOUNT_ID NUMBER(10) PRIMARY KEY,
	ACCOUNT_TYPE VARCHAR2(100),
	BALANCE NUMBER(20,2),
	APPROVED VARCHAR2(10) DEFAULT 'PENDING',
	INTEREST_RATE NUMBER(3,2) DEFAULT 0.00,
	ACCOUNT_OWNER NUMBER(10) REFERENCES BANK_USER
);


CREATE TABLE BANK_USER(
	USER_ID NUMBER(10) PRIMARY KEY,
	USER_ROLE VARCHAR2(40),
	USERNAME VARCHAR2(40) UNIQUE,
	PASSWORD VARCHAR2(64)
);



--INSERTING THE BANK_USERS
INSERT INTO BANK_USER VALUES(1,'CUSTOMER', 'DJSPARKS','IAMAWINNER');
INSERT INTO BANK_USER VALUES(2,'CUSTOMER', 'WALDO','IAMHIDDEN');
INSERT INTO BANK_USER VALUES(3,'CUSTOMER', 'STACY','PORRIDGE');
INSERT INTO BANK_USER VALUES(4,'EMPLOYEE', 'JOHNATAN','MODELINC');
INSERT INTO BANK_USER VALUES(5,'EMPLOYEE', 'DJOHNSON','PEOPLESCHAMP');

--INSERTING THE TYPES OF ACCOUNTS
INSERT INTO ACCOUNT VALUES(1001,'SAVINGS',5000.00,'APPROVED',.01,1);
INSERT INTO ACCOUNT VALUES(1002,'SAVINGS',10000.00,'PENDING',.02,2);
INSERT INTO ACCOUNT VALUES(1008,'SAVINGS',126065.10,'REJECTED',.03,3);
INSERT INTO ACCOUNT VALUES(1004,'SAVINGS',345210.57,0.05,4);
INSERT INTO ACCOUNT VALUES(1005,'CHECKING',3500,0,1);
INSERT INTO ACCOUNT VALUES(1006,'CHECKING',12836.19,0,2);
INSERT INTO ACCOUNT VALUES(1007,'CHECKING',256321.07,0,4);
INSERT INTO ACCOUNT VALUES(1008,'CHECKING',4256.25,0,5);


SELECT * FROM ACCOUNT;

SELECT USERNAME, ACCOUNT_TYPE, BALANCE FROM BANK_USER bu 
JOIN ACCOUNT a ON A.ACCOUNT_OWNER = BU.USER_ID;

SELECT USERNAME, PASSWORD FROM BANK_USER bu 
WHERE BU.USERNAME = 'DJOHNSON';

--TRUNCATE TABLE ACCOUNT
TRUNCATE TABLE BANK_USER

DROP TABLE ACCOUNT;


UPDATE ACCOUNT 
SET APPROVED = 'ACCEPTED'
WHERE ACCOUNT_ID = 1001;

SELECT USER_ID,USERNAME,ACCOUNT_ID,ACCOUNT_TYPE,BALANCE,INTEREST_RATE,APPROVED FROM BANK_USER bu 
JOIN ACCOUNT acc 
ON acc.ACCOUNT_OWNER = USER_ID
WHERE USER_ROLE = 'CUSTOMER' AND acc.APPROVED = 'PENDING';

--DROP TABLE CUSTOMER_ACCOUNT_JOIN;
--DROP TABLE ACCOUNT;
--DROP TABLE BANK_USER;